cut;

[mlbasics_=Prop];

(** DEFINITION OF THE DATATYPES AND AXIOMS **)

(** Product **)
[PROD[A,B:Prop] = {C|Prop}(A->B->C)->C];
[A,B|Prop]
[p[a:A][b:B] = [X|Prop][h:A->B->X]h a b :PROD A B];
[pi1 [p:PROD A B]=p([a:A][_:B]a)];
[pi2 [p:PROD A B]=p([_:A][b:B]b)];
Discharge A;
(** Induction principle **)
[prod_eta_elem:{A,B|Prop}{e:PROD A B}Q e (p (pi1 e) (pi2 e))];

(** Sum **)
[SUM[A,B:Prop] = {C|Prop} (A->C) -> (B->C) -> C]
[A,B|Prop];
[case[C|Prop][f:A->C][g:B->C] = [s:SUM A B](s f g)]
[i1 [a:A] =[X|Prop][f:A->X][g:B->X](f a):SUM A B];
[i2 [b:B] =[X|Prop][f:A->X][g:B->X](g b):SUM A B];
Discharge A;
(** Induction principle **)
[sumind:{A,B:Prop} {P:(SUM A B)  ->Prop}
          ({a:A}P(i1 a)) -> ({b:B}P(i2 b)) -> {x:SUM A B}P x];


(** Unit Type **)
[Unit={A|Prop}A->A];
[star:Unit=[A|Prop][a:A]a];
(** Induction principle **)
[unitind:{u:Unit}Q star u];

(** Truth Values **)
[bool = {C|Prop}C->C->C];
[true = [C|Prop][t:C][_:C]t];
[false = [C|Prop][_:C][f:C]f];
[if[A|Prop][b:bool][a1,a2:A] = b a1 a2];
(** Induction principle and consistency assumption**)
[boolind:{P:bool -> Prop} (P true) -> (P false) -> {b:bool} P b];
[consistency:not (Q true false)];

(** The natural numbers **)
[nat={C|Prop}C->(C->C)->C];
[zero:nat=[C|Prop][z:C][s:C->C]z];
[succ[n:nat]:nat=[C|Prop][z:C][s:C->C]s(n z s)];
(** Induction principle **)
[natind:{P:nat->Prop}(P zero)->
     ({n:nat}(P n)->P (succ n))->{n:nat}P n];

(** Primitive recursion **)
[natrec[R|Prop][g:R][h:nat->R->R]:nat->R =
  [n:nat]pi2 (n (p zero g) 
              ([nxr:PROD nat R]
                     p (succ (pi1 nxr))
                          (h (pi1 nxr)(pi2 nxr))))];
          

(** The lists **)
[list[E:Prop] = {C|Prop}C -> (E->C->C) -> C];
[nil[E:Prop] = [C|Prop][n:C][c:E->C->C]n];
[cons[E|Prop][e:E][l:list E] = [C|Prop][n:C][c:E->C->C] c e (l n c)];
[listrec[E|Prop][R|Prop][g:R][h:E->(list E)->R->R]:(list E) -> R =
  [l:list E]pi2 (l (p (nil E) g)
                 ([e:E][lxr:PROD (list E) R]
                         p (cons e (pi1 lxr))
                           (h e (pi1 lxr) (pi2 lxr))))];
(** Induction principle **)
[listind:{E|Prop}{P:(list E)->Prop} (P (nil E)) ->
                 ({e:E}{l:list E}(P l) -> P (cons e l)) -> {l:list E} P l];


(** FURTHER DEFINITIONS **)

(** Boolean algebra structure on bool **)
[orelse[b1,b2:bool] = if b1 true b2];
[andalso[b1,b2:bool] = if b1 b2 false];
[implies:bool->bool->bool=[b1,b2:bool]if b1 b2 true];
[negate:bool->bool=[b:bool]if b false true];

(** Relation to Prop **)
[isthecase = [b:bool]Q true b];
[isnotthecase = [b:bool]Q false b];


Goal {b:bool}or (isthecase b)(isnotthecase b);
Refine boolind ([x:bool]or (isthecase x)(isnotthecase x));
Refine inl;Refine Q_refl;Refine inr;Refine Q_refl;
Save bycases;

Goal {A:Prop}{a1,a2:A}{b:bool}(isthecase b)->Q a1 (if b a1 a2);
intros;Refine H([x:bool]Q a1 (if x a1 a2));Refine Q_refl;
Save iftrue;

Goal {A:Prop}{a1,a2:A}{b:bool}(isnotthecase b)->Q a2 (if b a1 a2);
intros;Refine H([x:bool]Q a2 (if x a1 a2));Refine Q_refl;
Save iffalse;

Goal {A:Prop}{a1,a2:A}{P:A->Prop}{b:bool}
                    ((isthecase b)->P a1)->
                    ((isnotthecase b)->P a2)->
                           P(if b a1 a2);
Intros ____;Refine boolind[b:bool]((isthecase b)->P a1)->((isnotthecase b)->P a2)->P (if b a1 a2);
intros;Refine H;Refine Q_refl;intros;Refine H1;Refine Q_refl;
Save ifind;

Goal {b1,b2:bool}Q(orelse b1 b2)(orelse b2 b1);
Refine boolind [b1:bool]{b2:bool}Q (orelse b1 b2) (orelse b2 b1);
Refine boolind [b2:bool]Q (orelse true b2) (orelse b2 true);Refine Q_refl;Refine Q_refl;
Refine boolind [b2:bool]Q (orelse false b2) (orelse b2 false);Refine Q_refl;Refine Q_refl;
Save orelse_commutes;

Goal {b1,b2:bool}iff (isthecase
             (orelse b1 b2))(or (isthecase b1)(isthecase b2));
Refine boolind [b1:bool]{b2:bool}
 iff (isthecase (orelse b1 b2)) (or (isthecase b1) (isthecase b2));
Intros b2;andI;Intros _;Refine inl;Refine Q_refl;Intros _;Refine Q_refl;
Intros b2;andI;Intros _;Refine inr;Immed;Intros _;Refine H;
Intros H1;Refine consistency;Immed;Refine I;
Save orelse_correct;

Goal {b1,b2:bool}iff (isthecase
             (andalso b1 b2))(and (isthecase b1)(isthecase b2));
Refine boolind[b1:bool]{b2:bool}
  iff (isthecase (andalso b1 b2)) (and (isthecase b1) (isthecase b2));
Intros b2;andI;Intros H;andI;Refine Q_refl;Immed;Intros H;Refine snd H;
Intros b2;andI;Intros H;Refine consistency H;Intros H;Refine fst H;
Save andalso_correct;

Goal {b:bool}iff (isnotthecase b) (not (isthecase b));
Intros _;andI;Intros __;Refine consistency (Q_trans H1 (Q_sym H));
Intros _;Refine bycases b;Intros H1;Refine H H1;Refine I;
Save isnotthecase_correct;


Goal {A|Prop}{a:bool}(isthecase a)->(isnotthecase a)->A;
Intros ____;Refine consistency (Q_trans H (Q_sym H1)) A;
Save contradiction;


(** FURTHER DEFINITIONS FOR THE NATURAL NUMBERS **)

Goal {R|Prop}{g:R}{h:nat->R->R}Q g (natrec g h zero);
intros;Refine Q_refl;
Save natrec_zero;

Goal {R|Prop}{g:R}{h:nat->R->R}{n:nat}Q (h n (natrec g h n))(natrec g h (succ n));
intros;Refine Q_resp [x:nat]h x (natrec g h n);
Refine natind [n:nat]Q n (pi1 (n (p zero g) ([nxr:PROD nat R]p (succ (pi1 nxr))
 (h (pi1 nxr) (pi2 nxr)))));Refine Q_refl;Intros n indhyp;Refine Q_resp;Refine indhyp;
Save natrec_succ;


(** Double induction **)
Goal {P:nat->nat->Prop} (P zero zero)->({n:nat}(P zero n)-> P zero (succ n))->
     ({m:nat}({n:nat}P m n)->P (succ m) zero)->({m:nat}({n:nat}P m n)-> 
     {n:nat}(P (succ m) n)->P (succ m) (succ n))->
          {m,n:nat}P m n;
Intros _____;Refine natind [m:nat]{n:nat}P m n;Refine natind;Immed;Intros __;Refine natind;
Immed;Refine H2;Immed;Intros __;Refine H3;Immed;
Save double_natind;

Goal {n:nat}not (Q (succ n) zero);
Intros n H;Refine consistency (Q_resp ([n'3:nat]n'3 false ([_:bool]true)) H);
Save not_succ_zero;

(** predecessor **)

[pred=natrec zero ([n,_:nat]n)];

Goal {n:nat}Q n (pred (succ n));
Intros n;Refine natrec_succ;Refine Q_refl;
Save pred_inverts_succ;

Goal {m,n:nat}(Q (succ m) (succ n))->Q m n;
Intros m n H;Refine Q_trans;Next +1;Refine pred_inverts_succ;Refine Q_sym;
Refine Q_trans;Next +1;Refine pred_inverts_succ;Refine Q_resp pred;Refine Q_sym H;
Save succ_injective;


(** Ordering on nat **)

[stable[P:nat->Prop]={n:nat}(P n)->P (succ n)];
[LE[m,n:nat]={P:nat->Prop}(stable P)->(P m)->(P n)];
[LT[m,n:nat]=LE (succ m) n];

Goal {n:nat}LE n n;
Intros;Immed;
Save LE_refl;

Goal {m,n:nat}(LE m n)->LE m (succ n);
Intros;Refine H1;Refine H;Immed;
Save LE_ind;

Goal {m,n:nat}(LE m n)->LE (succ m) (succ n);
Intros ___;Refine H ([n'4:nat]LE (succ m) (succ n'4));
Intros n1;Refine LE_ind;Refine LE_refl;
Save LE_incr;


Goal {n:nat}LT n (succ n);
Intros n;Refine LE_refl;
Save succ_incr;

Goal {l,m,n:nat}(LE l m)->(LE m n)->LE l n;
Intros;Refine H1;Immed;Refine H;Immed;
Save LE_trans;

Goal {l,m,n:nat}(LT l m)->(LT m n)->LT l n;
Intros _____;Refine LE_trans;Refine succ m;Refine LE_ind;Immed;
Save LT_trans;

Goal {m:nat}LE zero m;
Intros;Refine natind;Immed;
Save LE_zero_m;

Goal {m,n:nat}(LE m n)->or (Q m n) (LT m n);
Intros ___;Refine H ([n'4:nat]or (Q m n'4) (LT m n'4));
Intros __;Refine H1;Intros _;Refine inr;Qrepl H2;Refine succ_incr;Intros _;
Refine inr;Refine LT_trans;Next +1;Refine H2;Refine succ_incr;Refine inl;Refine Q_refl;
Save LEandLT;


Goal {m:nat}LE (pred (succ m)) (succ (pred m));
Intros m;Qrepl (Q_sym (pred_inverts_succ m));Refine natind [m:nat]LE m (succ (pred m));
Refine LE_zero_m;intros;Qrepl (Q_sym (pred_inverts_succ n));Refine LE_refl;
Save succ_retracts_pred;


Goal {n:nat}LE (pred n) n;
Refine natind [n:nat]LE (pred n) n;Refine LE_refl;
intros;Qrepl (Q_sym (pred_inverts_succ n));Refine LE_ind;Refine LE_refl;
Save pred_decr;

Goal {m,n:nat}(LE (succ m)(succ n))->LE m n;
Intros ___;Qrepl pred_inverts_succ m;Qrepl pred_inverts_succ n;
Refine H [x:nat]LE (pred (succ m)) (pred x);
Intros __;Refine LE_trans;Next +1;Refine H1;Qrepl (Q_sym (pred_inverts_succ n1));
Refine pred_decr;Refine LE_refl;
Save LE_succ;

[is_succ[n:nat] = Ex ([m:nat]Q n (succ m))];

Goal {n:nat}or (Q n zero) (is_succ n);
Refine natind [n:nat]or (Q n zero) (is_succ n);
Refine inl;Refine Q_refl;
Intros n H;Refine inr;Refine ExIntro;Refine n;Refine Q_refl;
Save im_succ;

Goal not (is_succ zero);
Intros H;Refine H;
Intros n H1;Refine not_succ_zero n;Refine Q_sym;Immed;
Save not_is_succ_zero;

Goal {n:nat}(LE n zero)->Q n zero;
Intros n;Refine im_succ n;Intros H H1;Refine H;
Intros H H1;Refine not_is_succ_zero;Refine not_is_succ_zero;
Refine H1 is_succ;Intros __;Refine ExIntro;Refine n1;Refine Q_refl;Immed;
Save zero_min;


(** FURTHER DEFINITIONS FOR THE LISTS **)

Goal {E:Prop}{R:Prop}{g:R}{h:E->(list E)->R->R}Q g (listrec g h (nil E));
intros;Refine Q_refl;
Save listrec_nil;

Goal {E:Prop}{R:Prop}{g:R}{h:E->(list E)->R->R}{l:list E}{e:E} 
            Q (h e l (listrec g h l)) (listrec g h (cons e l));
intros;Refine Q_resp [x:list E]h e x (listrec g h l);Refine listind [l:list E]Q l 
(pi1 (l (p (nil E) g) ([e:E][lxr:PROD (list E) R]p (cons e (pi1 lxr)) (h e (pi1 lxr) (pi2 lxr)))));
Refine Q_refl;intros;Refine Q_resp (cons e1);Refine H; 
Save listrec_cons;


(** MISCELLANEOUS **)

[let[A,B|Prop]=[a:A][f:A->B]f a]; 

[unext:{A,B|Prop}{f,g:A->B}(Q f g)->{a:A}Q (f a) (g a)
=[A,B|Prop][f,g:A->B][qfg:Q f g][a:A]Q_resp ([x:A->B]x a) qfg];

[uselocal = [T|Type][P:T->Prop][B:Prop][H1:{t:T}(P t)->B][H2:Ex P]H2 B H1];

(** equality types **)

[eqtype[X:Prop][eq:X->X->bool]=
{x,y:X}iff (isthecase (eq x y)) (Q x y)];

[X|Prop][eq:X->X->bool][EQ:eqtype X eq];
[eq_sym:{x,y:X}(isthecase (eq x y))->isthecase (eq y x)
=
[x,y:X][xqy:isthecase (eq x y)]snd (EQ y x) (Q_sym (fst (EQ x y) xqy))]
[eq_refl:{x:X}isthecase (eq x x)
=
[x:X]snd (EQ x x) (Q_refl x)]
[eq_trans:{x,y,z:X}(isthecase (eq x y))->(isthecase (eq y z))->isthecase (eq x z)
=
[x,y,z:X][xqy:isthecase (eq x y)][yqz:isthecase (eq y z)]snd (EQ x z) (Q_trans (fst (EQ x y) xqy) (fst (EQ y z) yqz))];
Discharge X;

Goal {X|Prop}{eq:X->X->bool}(eqtype X eq)->{x,y:X}Q (eq x y) (eq y x);
intros;
Refine bycases (eq x y);
Intros eqxy;Refine bycases (eq y x);
Intros eqyx;Refine Q_trans;Next +2;Refine eqyx;
Refine Q_sym eqxy;
Intros neqyx;Refine contradiction (eq y x);
Refine eq_sym;Immed;
Intros neqxy;Refine bycases (eq y x);
Intros eqxy;Refine contradiction (eq x y);
Refine eq_sym;Immed;
Intros neqyx;Refine Q_trans;Next +2;Refine neqyx;
Refine Q_sym;Immed;
Save eq_sym';

(** Decidable equality for nat **)

[eq_nat:nat->nat->bool = natrec 
             (natrec true ([_:nat][_:bool]false))
             ([n:nat][eqn:nat->bool]natrec false ([m:nat][_:bool]eqn m))];

Goal eqtype nat eq_nat;
Expand eqtype;
Refine double_natind[x,y:nat]iff (isthecase (eq_nat x y)) (Q x y);
andI;Intros _;Refine Q_refl;Intros _;Refine Q_refl;
Intros n Hn;andI;Intros H;Refine consistency;Refine H;
Intros H;Refine not_succ_zero ? (Q_sym H);
Intros m hyp;andI;
Intros H;Refine consistency;Refine H;
Intros H;Refine not_succ_zero ? H;
Intros m hyp;Intros n hyp';
andI;Intros q;Refine Q_resp;Refine fst (hyp n);
Refine Q_trans;Next +1;Refine q;
Refine natrec_succ???[x:nat->bool]Q(x (succ n))(eq_nat m n);
Refine natrec_succ???[x:bool]Q x (eq_nat m n);Refine Q_refl;
Intros qq;Refine Q_trans;Next +1;Refine snd (hyp n);
Refine succ_injective;Immed;Refine Q_sym;
Refine natrec_succ???[x:nat->bool]Q(x (succ n))(eq_nat m n);
Refine natrec_succ???[x:bool]Q x (eq_nat m n);Refine Q_refl;
Save eqtype_nat;


(*** General Recursion by complexity measures ***)

[A,B|Prop][end:A->bool][base:A->B][scheme:A->(A->B)->B][w:A->nat];
[base_condition={a:A}(Q (w a) zero)->(isthecase (end a))];
[cont_condition={a:A}or (isthecase (end a))
    ({f1,f2:A->B}({a':A}(LT (w a') (w a))->Q (f1 a') (f2 a'))->Q (scheme a f1) (scheme a f2))];

[bcond:base_condition];
[ccond:cont_condition];
[rec_aux=
natrec
    base
   ([_:nat][upton:A->B][a:A]if (end a) (base a) (scheme a upton))];

[recurse[a:A] = rec_aux (w a) a];

Goal {n:nat}{a:A}(LE (w a) n)->
Q (rec_aux n a) (if (end a) (base a) (scheme a (rec_aux n)));
Refine natind [n:nat]{a:A}(LE (w a) n)->Q (rec_aux n a) (if (end a)
(base a) (scheme a (rec_aux n))); Intros a H;Refine Q_trans;Refine (base a);
Refine Q_sym;Refine unext ?? (natrec_zero ??); Refine Q_refl;
Refine iftrue;Refine bcond;Refine zero_min; Refine H; Intros n indhyp; 
Intros a H; Refine Q_trans;Refine if (end a) (base a) (scheme a (rec_aux n)); 
Refine Q_sym; Refine unext ??(natrec_succ ???);Refine Q_refl; Refine ccond a; 
Intros enda; Refine Q_trans;Refine (base a);Refine Q_sym;Refine iftrue;Refine enda;
Refine iftrue;Refine enda;Intros red; Refine Q_resp; Refine red; Intros a'; 
Intros lta'a; Refine Q_trans; Refine if (end a') (base a') (scheme a' (rec_aux n)); 
Refine indhyp; Refine LE_succ; Refine LE_trans; Refine w a; Immed;
Refine unext ?? (natrec_succ ???);Refine Q_refl;
Save rec_aux_lem1;

Goal {m,n:nat}{a:A}(LE (w a) m)->(LE m n)->Q (rec_aux m a)(rec_aux n a);
Refine double_natind 
     [m,n:nat]{a:A}(LE (w a) m)->(LE m n)->Q (rec_aux m a) (rec_aux n a);
(** m=0, n=0 **)
Intros ___;Refine Q_refl;

(** m=0 **)
Intros n indhyp a lewaz _;Refine Q_trans;Next +1;
Refine Q_sym;Refine unext ?? (natrec_zero ??);Refine Q_refl;
Refine Q_trans;Next +2;Refine unext ?? (natrec_succ ???);
Refine iftrue;Refine bcond;Refine zero_min;Immed;

(** n=0 **)
Intros m indhyp a lewasx lesxz;Refine Q_trans;Next +1;
Refine Q_sym;Refine unext ?? (natrec_succ ???);Refine Q_refl;
Refine Q_trans;Next +2;Refine unext ?? (natrec_zero ??);Refine Q_refl;
Refine Q_sym;Refine iftrue;Refine bcond;Refine zero_min;
Refine LE_trans;Refine succ m;Immed;

(** ind-step **)
Intros m indhyp n _ a lewasm lesmsn;Refine ccond a;

(** Case (end a) **)
Intros enda;Refine Q_trans;Refine base a;Refine Q_trans;Next +1;
Refine rec_aux_lem1;Immed;Refine Q_sym;Refine iftrue;Immed;
Refine Q_trans;Next +2;Refine Q_sym;Refine rec_aux_lem1;
Refine LE_trans;Refine succ m;Immed;Refine iftrue;Immed;

(** Recursion-case **)
Intros red;Refine Q_trans;Next +1;Refine Q_sym;Refine unext ?? (natrec_succ ???);
Refine Q_refl;Refine Q_trans;Next +2;Refine unext ?? (natrec_succ ???);
Refine Q_refl;Refine Q_resp;
Equiv Q (scheme a (rec_aux m)) (scheme a (rec_aux n));
Refine red;Intros a1 ltwa1wa;Refine indhyp;
Refine LE_succ;Refine LE_trans;Refine w a;
Immed;Refine LE_succ;Immed;
Save rec_aux_lem2;




Goal {a:A}Q (if (end a) (base a) (scheme a recurse)) (recurse a);
Intros a;Refine ccond a;

(** Case (end a) **)
Intros enda;
Refine Q_trans;Refine base a;Refine Q_sym;Refine iftrue;Immed;
Refine Q_trans;Next +2;Refine Q_sym;Refine rec_aux_lem1;
Refine LE_refl;Refine iftrue;Immed;

(** Recursion case **)
Intros red;Refine Q_trans;Next +2;Refine Q_sym;Refine rec_aux_lem1;
Refine LE_refl;Refine Q_resp;Refine red;Intros a1 ltwa1wa;
Refine rec_aux_lem2;Refine LE_refl;Refine LE_succ;Refine LE_ind;Immed;
Save recurse_law;

[index_induction:{P:A->Prop}({a:A}({a':A}(LT (w a') (w a))->P a')->P a)->{a:A}P a
=
[P:A->Prop][indhyp:{a:A}({a':A}(LT (w a') (w a))->P a')->P a][a:A]
natind ([n:nat]{a'5:A}(LE (w a'5) n)->P a'5) ([a'4:A][lewaz:LE (w a'4) zero]
indhyp a'4 ([a':A][ltwa'wa:LT (w a') (w a'4)]not_is_succ_zero 
(ex_intro ([m:nat]Q zero (succ m)) (Q_sym (zero_min (succ (w a')) 
(LE_trans (succ (w a')) (w a'4) zero ltwa'wa lewaz)))) (P a'))) 
([n:nat][indhyp2:{a'5:A}(LE (w a'5) n)->P a'5][a'6:A][lewasn:LE (w a'6) 
(succ n)]indhyp a'6 ([a':A][ltwa'wa:LT (w a') (w a'6)]indhyp a' 
([a1:A][ltwa1wa':LT (w a1) (w a')]indhyp2 a1 (LE_trans (w a1) (w a') n 
(LE_trans (w a1) (succ (w a1)) (w a') (LE_ind (w a1) (w a1) (LE_refl (w a1))) ltwa1wa') 
(LE_succ (w a') n (LE_trans (succ (w a')) (w a'6) (succ n) ltwa'wa lewasn)))))) 
(w a) a (LE_refl (w a))];

Goal {P:A->B->Prop}
   ({a:A}(isthecase (end a))->P a (base a))->
   ({f:A->B}{a:A}({a':A}(LT (w a') (w a))->P a' (f a'))->P a (scheme a f))->
   {a:A}P a (recurse a);

Intros P Pbase Pstab;Claim  {n:nat}{a:A}(LE (w a) n) -> P a (rec_aux n a);
Intros a;Refine ?2 (w a);Refine LE_refl;
Refine natind [n:nat]{a:A}(LE (w a) n)->P a (rec_aux n a);

(** base case **)
Intros a lewaz;Refine (unext ??(natrec_zero ??)?)(P a);
Refine Pbase;Refine bcond;Refine zero_min;Immed;

(** Inductive case **)
Intros n indhyp;Intros a lewasn;
Refine (unext ?? (natrec_succ ???) ?) (P a);
Refine ifind ??? (P a);Intros enda;Refine Pbase;Refine enda;
Intros _;Refine Pstab;Intros a' ltwa'wa;Refine indhyp;
Refine LE_succ;Refine LE_trans;Refine w a;Immed;
Save recind2;

Goal {P:A->(A->B)->Prop}{maxeval:A->nat}
({a1,a2:A}(LT (w a1) (w a2))->LT (maxeval a1) (maxeval a2))->
({a:A}{f1,f2:A->B}({a':A}(LE (w a')(maxeval a))
->Q (f1 a')(f2 a'))->(P a f1)->P a f2)->
({a:A}(Q (maxeval a)zero)->P a base)->
({f:A->B}{a:A}({a':A}(LT (w a')(w a))->P a' f) ->P a ([a:A]if (end a) (base a)
(scheme a f)))->
{a:A}P a recurse;
Intros P maxeval maxeval_monoton Pcont Pbase Pstab a;
Refine Pcont;Refine rec_aux (maxeval a);
Intros a' lewa'ma;Refine Q_sym;
Refine rec_aux_lem2;Refine LE_refl;
Immed;Refine index_induction[a:A]P a (rec_aux (maxeval a));
Intros a1;Intros indhyp;Refine im_succ (maxeval a1);
Intros qmaz;Refine Q_sym qmaz [n:nat]P a1 (rec_aux n);
Refine natrec_zero ??(P a1);Refine Pbase;
Refine qmaz;Intros iss;Refine iss;Intros n1 qmasn1;
Refine Q_sym qmasn1[x:nat]P a1 (rec_aux x);Refine natrec_succ ???(P a1);
Equiv P a1 ([a:A]if (end a) (base a) (scheme a (rec_aux n1)));Refine Pstab;
Intros a' ltwa'wa1;Refine Pcont;Refine rec_aux (maxeval a');
Intros a2 lewa2ma';Refine rec_aux_lem2;Immed;
Refine LE_succ;Refine LE_trans;Refine maxeval a1;Refine maxeval_monoton;Immed;
Refine qmasn1[x:nat] LE (maxeval a1) x;
Refine LE_refl;Refine indhyp;Immed;
Save rec_ind;
Discharge A; (* ,B, bcond, ccond, w, ... *)




